#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <math.h>
#include <ctype.h>
#include <limits.h>


#define xDEBUG 1

struct xy {
	int x,y;
	} F[25000];

#define mymin(a,b) ((a)>(b) ? (b) : (a))
#define mymax(a,b) ((a)<(b) ? (b) : (a))

static int Felem_compar(const struct xy *ap,const struct xy *bp)
{
int r;

	r=(*ap).y-(*bp).y;
	if (r)
		return(r);
	return (*ap).x-(*bp).x;
}

int main(void)
{
int N,n;
int i;
int Xmin,Xmax,Ymin,Ymax,Xcen,Ycen;

	for (;;) {
		i=scanf("%d\n",&N);
		assert(i==1);
		if (N==0)
			break;
		Xmin=INT_MAX;
		Xmax=INT_MIN;
		Ymin=INT_MAX;
		Ymax=INT_MIN;
		for (n=0;n<N;n++) {
			i=scanf("%d %d\n",&F[n].x,&F[n].y);
			assert(i==2);
			F[n].x*=2;
			F[n].y*=2;
			Xmin=mymin(Xmin,F[n].x);
			Xmax=mymax(Xmax,F[n].x);
			Ymin=mymin(Ymin,F[n].y);
			Ymax=mymax(Ymax,F[n].y);
			}
		Xcen=(Xmin+Xmax)/2;
		Ycen=(Ymin+Ymax)/2;
		qsort(F,N,sizeof(*F),(int (*)(const void *,const void *))Felem_compar);
#ifdef DEBUG
		for (n=0;n<N;n++) {
			printf("%d %d\n",F[n].x/2,F[n].y/2);
			}
#endif
		for (n=0;n<N;n++) {
			if (Xcen-F[n].x!=F[N-1-n].x-Xcen || Ycen-F[n].y!=F[N-1-n].y-Ycen) {
#ifdef DEBUG
				printf("BAD: %d %d\n",F[n].x/2,F[n].y/2);
#endif
				goto bad;
				}
			}
#ifdef DEBUG
		printf("INTERNAL: Xcen=%d,Ycen=%d\n",Xcen,Ycen);
#endif
		printf("V.I.P. should stay at (%d.%d,%d.%d).\n",
				Xcen/2,(Xcen%2 ? 5 : 0),Ycen/2,(Ycen%2 ? 5 : 0));
		continue;
bad:
		puts("This is a dangerous situation!");
		}
	return 0;
}
